%Computes fit for Volume in inelastic case based on matching moments

function F = FitVolumeInel(dxx)

global kr sir sib T;

% Empirical volume
% Monthly volume: Ratio tau<=2 years, 2<tau<=3 years, 3<tau<=6 years, 6<x<=7 years, 7<x<=11
% years, and 11<x years, to total volume
% Average Apr 2013 - Jan 2020, no T-bills
Volumeemp = [ 0.199	 0.132	0.292	0.080	0.204	0.094 ];
% % Average Apr 2013 - Jan 2020, with T-bills
% Volumeemp = [ 0.342	 0.108	0.240	0.065	0.167	0.077 ];

% Theoretical volume

ThVolume=T+0.1;
Tten = 10*T+1;
tauVolume = 0.00001 : 0.1 : ThVolume;

dalxx = dxx(1);
dthxx = dxx(2);

Volume = exp(-dalxx*tauVolume)-exp(-dthxx*tauVolume);
VolumeTotal = sum(Volume(1:Tten));
VolumeBelow2 = sum(Volume(1:21))/VolumeTotal;
VolumeBetween11and30 = sum(Volume(112:Tten))/VolumeTotal;

FitVolume(1) = (VolumeBelow2-Volumeemp(1))^2;
FitVolume(6) = (VolumeBetween11and30-Volumeemp(6))^2;
F = FitVolume(1)+FitVolume(6);

end