% Minimizes SSR over grid

clear;
close all ;

global kr sir sib T;


% Solve for dalx and dthx in inelastic case

dalopt0 = 0.4;
dthopt0 = 0.8;
dopt0 = [ dalopt0 dthopt0 ];

options=optimset('MaxFunEvals',100000,'MaxIter',10000,'Display','off');

[doptinel,fval,exitflag] = fminsearch(@FitVolumeInel,dopt0,options);
   
daloptinel = round(doptinel(1),3);
dthoptinel = round(doptinel(2),3);

disp(['daloptinel     = ',num2str(daloptinel)]);
disp(['dthoptinel     = ',num2str(dthoptinel)]);


% Starting values

SSRopt = 1e6;
kbopt = 0;
aalopt = 0;
athopt = 0;

hkbmaxinel = 0.02;

daloptinel = 0.269;
dthoptinel = 0.279;
       

% Grid

for kbxx = 0.126 : 0.0005 : 0.127
    
    for aalxx = 80.2 : 0.05 : 80.3
    
Irinel = Hint(kr,daloptinel,dthoptinel);

Ihbinel = Hint(hkbmaxinel,daloptinel,dthoptinel);

athxxmin = round((abs(kbxx-hkbmaxinel)/(sir*sib*(Irinel/kr)*(Ihbinel+(kr*Irinel-hkbmaxinel*Ihbinel)/(hkbmaxinel-kr))))^0.5);

athxxmin = 5290;
athxxmax = 5320;

        for athxx = athxxmin : 0.05 : athxxmax   
                              
                X=SSR(kbxx,aalxx,athxx,daloptinel,dthoptinel);
                                            
                disp(['X     = ',num2str(X)]);
                disp(['kbxx     = ',num2str(kbxx)]);
                disp(['aalxx     = ',num2str(aalxx)]);
                disp(['athxx     = ',num2str(athxx)]);
                disp(['SSRopt     = ',num2str(SSRopt)]);
                disp(['kbopt     = ',num2str(kbopt)]);
                disp(['aalopt     = ',num2str(aalopt)]);
                disp(['athopt     = ',num2str(athopt)]);
                
                if X>=1e5
                    
                    athxxmin1 = athxx-1;
                    athxxmax1 = athxx-0.1;
                    
                    for athxx = athxxmin1 : 0.1 : athxxmax1
                                                           
                        X=SSR(kbxx,aalxx,athxx,daloptinel,dthoptinel);
                                                
%                 disp(['X     = ',num2str(X)]);
%                 disp(['kbxx     = ',num2str(kbxx)]);
%                 disp(['aalxx     = ',num2str(aalxx)]);
%                 disp(['athxx1     = ',num2str(athxx)]);
%                 disp(['SSRopt     = ',num2str(SSRopt)]);
%                 disp(['kbopt     = ',num2str(kbopt)]);
%                 disp(['aalopt     = ',num2str(aalopt)]);
%                 disp(['athopt     = ',num2str(athopt)]);           
                       
                
                        if X>=1e5
                            break;
                            
                            
                        elseif X<SSRopt               
               
                        SSRopt = X;
                        kbopt = kbxx;
                        aalopt = aalxx;
                        athopt = athxx;
                        end
                    end
                    break;                         
                                                                   
                elseif X<SSRopt                
               
                    SSRopt = X;
                    kbopt = kbxx;
                    aalopt = aalxx;
                    athopt = athxx;
                    
%                 elseif X>SSRopt && X<1e5 && X1<X-0.0001
%                     
%                     athxxmin = athxx-19;
%                     athxxmax = athxx-1;
%                     
%                     for athxx = athxxmin : 0.5 : athxxmax
%                         
%                         X=SSRinel(kbxx,aalxx,athxx,dalopt,dthopt);
%                                                 
% %                 disp(['X     = ',num2str(X)]);
% %                 disp(['kbxx1     = ',num2str(kbxx)]);
% %                 disp(['aalxx1     = ',num2str(aalxx)]);
% %                 disp(['athxx1     = ',num2str(athxx)]);
%                         
%                         if X<SSRopt               
%                
%                         SSRopt = X;
%                         kbopt = kbxx;
%                         aalopt = aalxx;
%                         athopt = athxx;
%                         end
%                     end
                    
                end       
            end
                       
    end
end
                disp(['SSRopt     = ',num2str(SSRopt)]);
                disp(['kbopt     = ',num2str(kbopt)]);
                disp(['aalopt     = ',num2str(aalopt)]);
                disp(['athopt     = ',num2str(athopt)]);