clear;
close all ;

global kr sir sib T;

% Maximum maturity

T=30;

% Risk aversion

a = 3*10.69;

% QE as % of GDP

DS = -0.12;

% Forward guidance

Drbar = -0.04;

% Mean reversion of one-off shock

kth = 0.2;
krb = 0.1;


% Annual yield changes, T-bills excluded

% % Values (dal,dth) and (kb,aal,ath) minimizing FitVolume and SSR, respectively
   
% Volatility level and change, correlation change, averaged across maturities
kr = 0.395;
sir = 0.0216^2;
sib = 0.0216^2;
% % Solution for dal that is optimal for volume in inelastic case
% dal = 0.257;
% dth = 0.666;
% kb = 0.103;
% aal = 44.6;
% ath = 191.8;
% Solution for dal, obtained by iterating from volume in inelastic case, and one of two solutions that yield decreasing volume after the hump as function of maturity
dal = 0.265; % FitVolume = [ 0.00016304 0.00029757 ]
dth = 0.308;
kb = 0.0975;
aal = 44.45;
ath = 643.75;

% % Volatility level, FBCS, correlation change, averaged across maturities
% kr = 0.355;
% sir = 0.0185^2;
% sib = 0.0185^2;
% % % Solution for dal that is optimal for volume in inelastic case
% % dal = 0.257;
% % dth = 0.666;
% % kb = 0.369;
% % aal = 10.2;
% % ath = 238;
% % Solution for dal, obtained by iterating from volume in inelastic case, and one of two solutions that yields decreasing volume after the hump as function of maturity
% dal = 0.33; % FitVolume = [ -0.0141 -0.0114 ]
% dth = 0.398; 
% kb = 0.3665;
% aal = 14.6;
% ath = 981.8;


% Solve for M

% % Initial condition, method 1 (sib=0)
% 
% options=optimset('MaxFunEvals',100000,'MaxIter',10000);
% 
% Hkr1 = @(x) x-kr-aal*sir*Fint(x,x,dal);
% hkr = fzero(Hkr1,kr,options);
% 
% x01 = Fint(hkr,hkr,dal);
% 
% % zb is coefficient of bt when sib=0 and kb=0
% 
% zb = ath*sir*Hint(hkr,dal,dth)/(1+aal*sir*(Gint(hkr,dal)-Fint(hkr,hkr,dal))/hkr);
% 
% % Itau2 = int_0^T tau^2*exp(-dalx*tau)*dtau
% 
% Itau2 = 2/dal^3*(1-exp(-dal*T)-dal*T*exp(-dal*T)-dal^2*T^2/2*exp(-dal*T));
% 
% x02 = (zb/hkr)^2*(Itau2 - 2*Gint(hkr,dal) + Fint(hkr,hkr,dal));
% 
% x03 = zb/hkr*(Gint(hkr,dal)-Fint(hkr,hkr,dal));
% 
% x04 = Hint(hkr,dal,dth);
% 
% % DItau1 = int_0^T tau*(exp(-dal*tau)-exp(-dth*tau))*dtau
% 
% DItau1 = 1/dal^2*(1-exp(-dal*T)-dal*T*exp(-dal*T))-1/dth^2*(1-exp(-dth*T)-dth*T*exp(-dth*T));
% 
% x05 = zb/hkr*(DItau1 - Hint(hkr,dal,dth));
% 
% M011 = kr+aal*sir*x01;
% 
% M012 = aal*sib*x03 ;
% 
% M021 = -sir*(ath*x04-aal*x03);
% 
% M022 = kb-sib*(ath*x05-aal*x02);


% Initial condition, method 2 (aal=0)

options=optimset('MaxFunEvals',100000,'MaxIter',10000);

Hkbloc = @(x)Hkb(x,kb,aal,ath,dal,dth);
                      
[hkb,fval,exitflag] = fsolve(Hkbloc,kb,options);

ZAb = sir*ath*Hint(kr,dal,dth)/(1+sir*aal*(Fint(kr,kr,dal)-Fint(kr,hkb,dal))/(hkb-kr));

M011 = kr+sir*aal*Fint(kr,kr,dal);

M012 = sib*aal*ZAb*(Fint(kr,kr,dal)-Fint(kr,hkb,dal))/(hkb-kr);

M021 = -sir*(ath*Hint(kr,dal,dth)-aal*ZAb*(Fint(kr,kr,dal)-Fint(kr,hkb,dal))/(hkb-kr));

M022 = kb-sib*ZAb*(ath*(Hint(kr,dal,dth)-Hint(hkb,dal,dth))-aal*ZAb*(Fint(kr,kr,dal)+Fint(hkb,hkb,dal)-2*Fint(kr,hkb,dal))/(hkb-kr))/(hkb-kr);      


% Solve non-linear system

M0 = [ M011 M012 M021 M022 ];

Mmatloc = @(M)Mmat(M,kb,aal,ath,dal,dth);
                      
[M,fval,exitflag] = fsolve(Mmatloc,M0,options);

Mm = [ M(1)    M(2)  ; 
      M(3)    M(4) ] ;
        
L = eig(Mm);

la1 = L(1);

la2 = L(2);

ph1= -(M(1)-la1)/M(3);

ph2= -(M(1)-la2)/M(3);

eigvalues = [la1 la2];
eigvector1 = [1 ph1];
eigvector2 = [1 ph2];

% Display

disp(['Eigenvalues     = ',num2str(eigvalues)]);
disp(['Eigenvector 1     = ',num2str(eigvector1)]);    
disp(['Eigenvector 2     = ',num2str(eigvector2)]); 

% Curves

% coefs in Ar

cAr1 = -ph2/(ph1-ph2); %coef of (1-exp(-la1*tau))/la1

cAr2 = ph1/(ph1-ph2); %coef of (1-exp(-la2*tau))/la2

% coefs in Ab

cAb1 = 1/(ph1-ph2); %coef of (1-exp(-la1*tau))/la1

cAb2 = -1/(ph1-ph2); %coef of (1-exp(-la2*tau))/la2

Th=T+0.5;
Ttwo=2*T+1;

tau = 0.00001 : 0.5 : Th;

Ar = cAr1*(1-exp(-la1*tau))/la1 + cAr2*(1-exp(-la2*tau))/la2;

Ab = cAb1*(1-exp(-la1*tau))/la1 + cAb2*(1-exp(-la2*tau))/la2;

Arb = (cAr1*(1-exp(-la1*tau))/la1 + cAr2*(1-exp(-la2*tau))/la2)./tau;

Abb = (cAb1*(1-exp(-la1*tau))/la1 + cAb2*(1-exp(-la2*tau))/la2)./tau;


% Fama-Bliss

sirunc = sir/2/kr;
sibunc = sib/2/kb;

Dn=3;
Dt=0.5*(Dn-1);

for n=Dn+1 : 1 : Ttwo
    n1=n-Dn+1;
    FBnum(1,n-Dn)=(Ar(n)-Ar(n1)*exp(-kr*Dt)-Ar(Dn))*(Ar(n)-Ar(n1)-Ar(Dn))*sirunc+(Ab(n)-Ab(n1)*exp(-kb*Dt)-Ab(Dn))*(Ab(n)-Ab(n1)-Ab(Dn))*sibunc;
    FBden(1,n-Dn)=(Ar(n)-Ar(n1)-Ar(Dn))^2*sirunc+(Ab(n)-Ab(n1)-Ab(Dn))^2*sibunc;
    FB(1,n-Dn)=FBnum(1,n-Dn)/FBden(1,n-Dn);
end

tauFB = Dt+0.5+0.00001 : 0.5 : Th;


% Campbell-Shiller

CS = zeros(Ttwo,Ttwo);

for n2 = 2 : 1 : Ttwo
    for n1 = 2 : 1 : n2-1
        
        n3=n2-n1+1;  
        tau1 = 0.5*(n1-1);
        tau2 = 0.5*(n2-1);
        tau3 = tau2-tau1;
        CSdepr = Ar(n3)/tau3*exp(-kr*tau1)-Ar(n2)/tau2;
        CSdepb = Ab(n3)/tau3*exp(-kb*tau1)-Ab(n2)/tau2;
        CSindr = tau1/tau3*(Ar(n2)/tau2-Ar(n1)/tau1);
        CSindb = tau1/tau3*(Ab(n2)/tau2-Ab(n1)/tau1);
        CS(n1,n2)=(CSdepr*CSindr*sirunc+CSdepb*CSindb*sibunc)/(CSindr^2*sirunc+CSindb^2*sibunc); 

    end
end

tauCS3 = 1.5+0.00001 : 0.5 : Th;


% Volatility of yields

Vol = 100*(sirunc*Ar.^2+sibunc*Ab.^2).^0.5./tau;


% Volatility of monthly yield changes

DVol = 100*(24*(sirunc*(1-exp(-kr/12))*Ar.^2+sibunc*(1-exp(-kb/12))*Ab.^2)).^0.5./tau;


% Volatility of annual yield changes

DVola = 100*(2*(sirunc*(1-exp(-kr))*Ar.^2+sibunc*(1-exp(-kb))*Ab.^2)).^0.5./tau;


% Correlation matrix

Correl = 100^2*(sirunc*(Ar./tau).'*(Ar./tau)+sibunc*(Ab./tau).'*(Ab./tau))./(Vol.'*Vol);


% Correlation matrix of monthly yield changes 

DCorrel = 100^2*24*(sirunc*(1-exp(-kr/12))*(Ar./tau).'*(Ar./tau)+sibunc*(1-exp(-kb/12))*(Ab./tau).'*(Ab./tau))./(DVol.'*DVol);


% Correlation matrix of annual yield changes 

DCorrela = 100^2*2*(sirunc*(1-exp(-kr))*(Ar./tau).'*(Ar./tau)+sibunc*(1-exp(-kb))*(Ab./tau).'*(Ab./tau))./(DVola.'*DVola);


% Volume

Volume = (aal^2*exp(-dal*tau).^2.*Ar.^2*sir+(aal*exp(-dal*tau).*Ab-ath*(exp(-dal*tau)-exp(-dth*tau))).^2*sib).^0.5;


% Unantipated supply shocks

DIrr = cAr1^2*(Fint(kth,la1,dal)-Hint(la1,la1+dal,kth+dal)/(kth-la1))/la1 + cAr2^2*(Fint(kth,la2,dal)-Hint(la2,la2+dal,kth+dal)/(kth-la2))/la2 + cAr1*cAr2*((Fint(kth,la2,dal)-Hint(la2,la1+dal,kth+dal)/(kth-la1))/la1+(Fint(kth,la1,dal)-Hint(la1,la2+dal,kth+dal)/(kth-la2))/la2);
DIbb = cAb1^2*(Fint(kth,la1,dal)-Hint(la1,la1+dal,kth+dal)/(kth-la1))/la1 + cAb2^2*(Fint(kth,la2,dal)-Hint(la2,la2+dal,kth+dal)/(kth-la2))/la2 + cAb1*cAb2*((Fint(kth,la2,dal)-Hint(la2,la1+dal,kth+dal)/(kth-la1))/la1+(Fint(kth,la1,dal)-Hint(la1,la2+dal,kth+dal)/(kth-la2))/la2);
DIrb = cAr1*cAb1*(Fint(kth,la1,dal)-Hint(la1,la1+dal,kth+dal)/(kth-la1))/la1 + cAr2*cAb2*(Fint(kth,la2,dal)-Hint(la2,la2+dal,kth+dal)/(kth-la2))/la2 + cAr1*cAb2*(Fint(kth,la2,dal)-Hint(la2,la1+dal,kth+dal)/(kth-la1))/la1 + cAr2*cAb1*(Fint(kth,la1,dal)-Hint(la1,la2+dal,kth+dal)/(kth-la2))/la2;
DIbr = cAr1*cAb1*(Fint(kth,la1,dal)-Hint(la1,la1+dal,kth+dal)/(kth-la1))/la1 + cAr2*cAb2*(Fint(kth,la2,dal)-Hint(la2,la2+dal,kth+dal)/(kth-la2))/la2 + cAr2*cAb1*(Fint(kth,la2,dal)-Hint(la2,la1+dal,kth+dal)/(kth-la1))/la1 + cAr1*cAb2*(Fint(kth,la1,dal)-Hint(la1,la2+dal,kth+dal)/(kth-la2))/la2;

DI = (1+aal*sir*DIrr)*(1+aal*sib*DIbb)-aal^2*sir*sib*DIrb*DIbr;

Lar = DS*a*(sir*Ar*(1+aal*sib*DIbb)-sib*Ab*aal*sir*DIbr)/DI;
Lab = DS*a*(sib*Ab*(1+aal*sir*DIrr)-sir*Ar*aal*sib*DIrb)/DI;

Arint = (cAr1*((1-exp(-kth*tau))/kth-(exp(-la1*tau)-exp(-kth*tau))/(kth-la1))/la1 + cAr2*((1-exp(-kth*tau))/kth-(exp(-la2*tau)-exp(-kth*tau))/(kth-la2))/la2)./tau; 
Abint = (cAb1*((1-exp(-kth*tau))/kth-(exp(-la1*tau)-exp(-kth*tau))/(kth-la1))/la1 + cAb2*((1-exp(-kth*tau))/kth-(exp(-la2*tau)-exp(-kth*tau))/(kth-la2))/la2)./tau;

Supplyeffect = 100*(Lar'*Arint+Lab'*Abint);


% One-off forward guidance
 
chir = kr*(1+aal*sib*DIbb)/DI;
chib = -kr*aal*sib*DIrb/DI;
 
Arfint = (cAr1*((1-exp(-krb*tau))/krb-(exp(-la1*tau)-exp(-krb*tau))/(krb-la1))/la1 + cAr2*((1-exp(-krb*tau))/krb-(exp(-la2*tau)-exp(-krb*tau))/(krb-la2))/la2)./tau; 
Abfint = (cAb1*((1-exp(-krb*tau))/krb-(exp(-la1*tau)-exp(-krb*tau))/(krb-la1))/la1 + cAb2*((1-exp(-krb*tau))/krb-(exp(-la2*tau)-exp(-krb*tau))/(krb-la2))/la2)./tau;
 
ArfintEH = ((1-exp(-krb*tau))/krb-(exp(-kr*tau)-exp(-krb*tau))/(krb-kr))./tau;
 
Forwardguidance = 100*Drbar*(chir*Arfint+chib*Abfint);
ForwardguidanceEH = 100*Drbar*ArfintEH;


% Principal components

CovMR = sir*Ar(5:41)'*Ar(5:41) + sib*Ab(5:41)'*Ab(5:41);

[pcR,latentR,explainedR] = pcacov(CovMR);

scaledpc1R = pcR(:,1)./(tau(5:41)')/pcR(1,1);

disp(['explainedR(1)     = ',num2str(explainedR(1))]);    
disp(['explainedR(2)     = ',num2str(explainedR(2))]);

CovMDy = sirunc*(1-exp(-kr/12))*(Ar(5:41)./tau(5:41)).'*(Ar(5:41)./tau(5:41))+sibunc*(1-exp(-kb/12))*(Ab(5:41)./tau(5:41)).'*(Ab(5:41)./tau(5:41));

[pcDy,latentDy,explainedDy] = pcacov(CovMDy);

scaledpc1Dy = pcDy(:,1)'/pcDy(1,1);

disp(['explainedDy(1)     = ',num2str(explainedDy(1))]);    
disp(['explainedDy(2)     = ',num2str(explainedDy(2))]); 


% Segmentation equilibrium

% yseg = (ath/aal)*(ones(1,61)-exp(-(dth-dal)*tau))./tau;


nFBCS = 2 : 1 : T-10;
nVol = 2 : 1 : T-10;


% Empirical values

% Jan 1999 - Jan 2021
% Annual FB coefficients from 2 to 20 years. Fill one-year yield with spline
FBemp = [ 0.517  0.709  0.868  0.977  1.047  1.091  1.122  1.152  1.189  1.236  1.297  1.371  1.459  1.560  1.673  1.796  1.927 2.064  2.205 ];
% Annual CS coefficients from 2 to 20 years. Fill one-year yield with spline
CSemp = [ -0.047  -0.247  -0.352  -0.432  -0.498  -0.554  -0.606  -0.655  -0.705  -0.757  -0.814  -0.877  -0.945  -1.018  -1.098  -1.181  -1.269  -1.360  -1.454 ];
% Unconditional volatility of yields from 2 to 20 years.  
Volemp = [ 1.593  1.557  1.529  1.494  1.453  1.410  1.368  1.328  1.292  1.259  1.229  1.203  1.180  1.159  1.141  1.125  1.111  1.099  1.087 ];
% Unconditional volatility of monthly yield changes from 2 to 20 years
DVolemp = [ 1.498 1.123	0.985	0.910	0.857	0.815	0.779	0.749	0.722	0.699	0.679	0.661	0.646	0.633	0.623	0.615	0.610	0.607	0.607 ];
% Unconditional volatility of annual yield changes from 2 to 20 years
DVolempa = [ 1.234	1.002	0.891	0.822	0.770	0.727	0.691	0.658	0.630	0.605	0.584	0.565	0.549	0.535	0.524	0.515	0.508	0.502	0.498 ];
% Unconditional correlations for two-year bond from 2 to 20 years
Correlemp = [ 1.000	0.976	0.942	0.914	0.892	0.873	0.857	0.843	0.830	0.818	0.807	0.796	0.786	0.777	0.769	0.761	0.754	0.748	0.742 ];
% Unconditional correlations of monthly yield changes for two-year bond, from 2 to 20 years
DCorrelemp = [ 1.000	0.925	0.821	0.751	0.709	0.680	0.656	0.634	0.611	0.588	0.564	0.539	0.515	0.492	0.470	0.451	0.433	0.418	0.405 ];
% Unconditional correlations of annual yield changes for two-year bond, from 2 to 20 years
DCorrelempa = [ 1.000	0.963	0.899	0.840	0.790	0.749	0.712	0.680	0.650	0.623	0.597	0.573	0.550	0.528	0.508	0.490	0.474	0.459	0.447 ];
% Fraction of annual yield changes explained by first principal component
explainedDyemp(1) = 85.2496;
% First principal component of annual yield changes
scaledpc1Dyemp = [  1.0000    0.9107    0.8496    0.7997    0.7550    0.7133    0.6742    0.6378    0.6041    0.5733    0.5454    0.5204    0.4983    0.4788    0.4620    0.4475    0.4352    0.4250    0.4167 ];


% Figures

figure(1);
h=plot(tau,Ar,tau,Ab);
set(h,'LineWidth',2.5);
xlim([0 T-10]);
legend('r','beta');
xlabel('Maturity (years)');

figure(2);
h=plot(tau,Arb,'r-',tau,Abb,'r--');
set(h,'LineWidth',2.5);
xlim([0 T]);
legend('r','beta');
xlabel('Maturity (years)');

figure(3);
h=plot(tauFB,FB,'r-',nFBCS,FBemp,'k+');
set(h,'LineWidth',2.5);
axis([0 T-10 0 3.5]);
xlabel('Maturity (years)'); 
ylabel('Fama-Bliss regression coefficient'); 
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'FBreal.eps','bounds','tight','Color','rgb');

figure(4);
h=plot(tauCS3,CS(3,4:Ttwo),'r-',nFBCS,CSemp,'k+');
set(h,'LineWidth',2.5);
axis([0 T-10 -2.5 1]);
xlabel('Maturity (years)'); 
ylabel('Campbell-Shiller regression coefficient'); 
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'CSreal.eps','bounds','tight','Color','rgb');

figure(5);
h=plot(tau(5:41),Vol(5:41),'r-',nVol,Volemp,'k+');
set(h,'LineWidth',2.5);
axis([0 T-10 0 3]);
xlabel('Maturity (years)'); 
ylabel('Volatility of yield -- Levels'); 
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'Volreal.eps','bounds','tight','Color','rgb');

figure(6);
h=plot(tau(5:41),DVola(5:41),'r-',nVol,DVolempa,'k+');
set(h,'LineWidth',2.5);
axis([0 T-10 0 1.5]);
xlabel('Maturity (years)'); 
ylabel('Volatility of yield -- Annual changes'); 
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'DVolareal.eps','bounds','tight','Color','rgb');

figure(7);
h=plot(tau(5:41),DCorrela(5,5:41),'r-',nVol,DCorrelempa,'k+');
set(h,'LineWidth',2.5);
axis([0 T-10 0 1]);
xlabel('Maturity (years)'); 
ylabel('Correlation with two-year yield -- Annual changes'); 
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'DCorrelareal.eps','bounds','tight','Color','rgb');

figure(8);
h=plot(tau(5:41),scaledpc1Dy,'r-',nVol,scaledpc1Dyemp,'k+');
set(h,'LineWidth',2.5);
axis([0 T-10 0 1.5]);
xlabel('Maturity (years)'); 
ylabel('First principal component -- Annual yield changes'); 
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'PCreal.eps','bounds','tight','Color','rgb');

figure(9);
h=plot(Volume(3:41),'r-');
set(h,'LineWidth',2.5);
axis([0 T 0 3]);
xlabel('Maturity (years)'); 
ylabel('Volume'); 
ax = gca;
ax.FontSize = 12;

QEweights = [0 0 0.0644 0 0 0 0.2587 0 0 0 0.2466 0 0 0 0.2409 0 0 0 0.0440 0 0 0 0.0450 0 0 0 0.0298 0 0 0 0.0092 0 0 0 0.0196 0 0 0 0.0185 0 0 0 0.0074 0 0 0 0 0 0 0 0 0 0 0 0.0020 0 0 0 0.0140 0 0];

QESupplyeffect = QEweights*Supplyeffect;

QEweightsCF15 = [0 0 0 0 0 0 0 0 0 0 0.2939 0 0 0 0.2409 0 0 0 0.1742 0 0 0 0.0450 0 0 0 0.0445 0 0 0 0.0243 0 0 0 0.0307 0 0 0 0.0355 0 0 0 0.0235 0 0 0 0 0 0 0 0 0 0 0 0.0339 0 0 0 0.0535 0 0];

QESupplyeffectCF15 = QEweightsCF15*Supplyeffect;

figure(10);
h=plot(tau,Supplyeffect(5,:),'m',tau,Supplyeffect(11,:),'r',tau,Supplyeffect(21,:),'g',tau,Supplyeffect(41,:),'b',tau,Supplyeffect(61,:),'k',tau,QESupplyeffect,'k--');
set(h,'LineWidth',2.5);
xlim([0 T]);
ylim([-2.6,0.1]);
xlabel('Maturity (years)'); 
ylabel('Yield change'); 
legend('2-yr','5-yr','10-yr','20-yr','30-yr','QE mix');
legend('Location','southwest');
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'QEreal02.eps','bounds','tight','Color','rgb');

figure(11);
h=plot(tau,Forwardguidance,'r-',tau,ForwardguidanceEH,'r--');
set(h,'LineWidth',2.5);
xlim([0 T]);
ylim([-2.1,0.6]);
xlabel('Maturity (years)'); 
ylabel('Yield change'); 
legend('Forward guidance','Forward guidance EH');
legend('Location','northwest');
ax = gca;
ax.FontSize = 12;

% exportfig(gcf,'ForwGuidreal01.eps','bounds','tight','Color','rgb');


