function F = Mmat(M,kbx,aalx,athx,dalx,dthx)

global kr sir sib T;


% Compute eigenvalues

Mm = [ M(1)    M(2)  ; 
      M(3)    M(4) ] ;
        
L = eig(Mm);

la1 = L(1);

la2 = L(2);


% Compute eigenvectors

ph1= -(M(1)-la1)/M(3);

ph2= -(M(1)-la2)/M(3);


% coefs in Ar

cAr1 = -ph2/(ph1-ph2); %coef of (1-exp(-la1*tau))/la1

cAr2 = ph1/(ph1-ph2); %coef of (1-exp(-la2*tau))/la2


% coefs in Ab

cAb1 = 1/(ph1-ph2); %coef of (1-exp(-la1*tau))/la1

cAb2 = -1/(ph1-ph2); %coef of (1-exp(-la2*tau))/la2


% Compute integrals

IAr2 = cAr1^2*Fint(la1,la1,dalx)+cAr2^2*Fint(la2,la2,dalx)+2*cAr1*cAr2*Fint(la1,la2,dalx);

IAb2 = cAb1^2*Fint(la1,la1,dalx)+cAb2^2*Fint(la2,la2,dalx)+2*cAb1*cAb2*Fint(la1,la2,dalx);

IArAb = cAr1*cAb1*Fint(la1,la1,dalx)+cAr2*cAb2*Fint(la2,la2,dalx)+(cAr1*cAb2+cAr2*cAb1)*Fint(la1,la2,dalx);

IArth = cAr1*Hint(la1,dalx,dthx)+cAr2*Hint(la2,dalx,dthx);

IAbth = cAb1*Hint(la1,dalx,dthx)+cAb2*Hint(la2,dalx,dthx);

M11it = kr+aalx*sir*IAr2;

M12it = aalx*sib*IArAb;

M21it = -sir*(athx*IArth-aalx*IArAb);

M22it = kbx-sib*(athx*IAbth-aalx*IAb2);


F = M - [ M11it M12it M21it M22it ];

end
